#!/bin/bash
# Version 0.0.4
# Date: 2007-08-10
#-------------------
#änderbare Variablen
#-------------------
DEBUG=true
svdrp="svdrpsend.pl"
commandNo=6
#------------------------
#nur im notfall verändern
#------------------------
searchurl="http://german.imdb.com/find?s=tt&q="
tempout="/tmp/htmlout"
moviedata="/tmp/moviedata"
#------------------
#keinesfalls ändern
#------------------
PLUGINCALL=0
CMDCONFCALL=1
RECCMDCONFCALL=2


function getHTML()
{
	#Suche ausführen
	lynx -dump -width=500 "$searchurl$1" > $tempout	
	tmpurl=$(grep -e 'http:\/\/german.imdb.com\/title\/tt[0-9]*\/' $tempout | head -1 | cut -d"." -f2-)
	#direkt bei der Suche zum eindeutigen Ergebnis weitergeleitet oder nicht?
	if [ "$(grep 'Overview' $tempout)" != "" ]
	#ja
	then
		titleurl=$searchurl$1
		if $DEBUG
		then
			echo "[imdb-search] $1 ergab einen eindeutigen Treffer: $titleurl"
		fi;
	#nein
	#hat die Suche wenigstens Treffer ergeben?
	elif [ $tmpurl != "" ]  
	#ja
	then
		#Popular titles?
		if [ "$(grep 'Popular Titles' $tempout)" != "" ]
		#ja
		then
			populartitleurl=$tmpurl
			if $DEBUG
			then
				echo "[imdb-search] $1 ergab einen 'Popular Title' Treffer: $populartitleurl"
			fi;
		#nein
		#Exact Match?
		elif [ "$(grep 'Exact Matches' $tempout)" != "" ]
		#ja
		then
			exactmatchurl=$tmpurl
			if $DEBUG
			then
				echo "[imdb-search] $1 ergab einen 'Exact Match' Treffer: $exactmatchurl"
			fi;
		#nein
		else
			bestresulturl=$tmpurl
			if $DEBUG
			then
				echo "[imdb-search] $1 ergab einen 'Approx|Partial Match' Treffer: $bestresulturl"
			fi;
		fi;
	#nein
	else
		if $DEBUG
		then
			echo "[imdb-search] $1 ergab keinen Treffer"
		fi;
	fi;
}


#anhand des/der Parameter überprüfen woher der Aufruf kam und $title festlegen
if [ $# -ge 1 ]
#Parameter gegeben => PLUGINCALL oder RECCMDCONFCALL
then
	#RECCMCONFCALL ?
	if [ "$(echo $1 | grep '/video')" != "" ]
	#ja
	then
		DEBUG=false
		calltype=$RECCMDCONFCALL
		title="$(grep -e '^T.*' $1/info.vdr | cut -d' ' -f2- | tr ' ' '+')"
		if $DEBUG
		then
			echo "[imdb-search] RECCMDCONFCALL: Suche nach $title"
		fi;
	#nein => PLUGINCALL
	else 
		calltype=$PLUGINCALL
		for arg in $*
		do
			title="$title+$arg"
		done
		if $DEBUG
		then
			echo "[imdb-search] PLUGINCALL: Suche nach $title"
		fi;
	fi;
#kein Parameter gegeben => CMDCONFCALL
else
	calltype=$CMDCONFCALL
	channel=$($svdrp chan | grep 250 | cut -d" " -f 2)
	title=$($svdrp lste $channel now | grep 215-T | cut -d" " -f 2-| tr ' ' '+') 	
	if $DEBUG
	then
		echo "[imdb-search] CMDCONFCALL: Suche nach $title"
	fi;
fi;


#Verschiedene Titel zum probieren
#Kompletter Titel - Titel vor der Klammer (falls vorhanden) - Titel in der Klammer (falls vorhanden)(Originaltitel?)
titles="$title  $(echo "$title" | grep '(' | cut -d"(" -f 1)  $(echo "$title" | grep '(' | cut -d"(" -f 2 | tr ')' ' ') "

#get HTML
for try in $titles
do		
	getHTML $try;
	if [ "$titleurl" != "" ] 
	then 
		break
	fi;
done	

if $DEBUG
then
	echo "[imdb-search] Suchergebnisse:"
	echo "[imdb-search] titleurl: $titleurl"
	echo "[imdb-search] populartitleurl: $populartitleurl"
	echo "[imdb-search] exactmatchurl: $exactmatchurl"
	echo "[imdb-search] bestresulturl: $bestresulturl"
fi;

#kein direkter Treffer, also weiterschauen
if [ "$titleurl" = "" ] 
then 
	#exakt?
	if [ "$exactmatchurl" != "" ]
	then
		result=$exactmatchurl
	#popular?
	elif [ "$populartitleurl" != "" ]
	then
		result=$populartitleurl
	#approx|partial?
	elif [ "$bestresulturl" != "" ]
	then
		result=$bestresulturl
	#nix?
	else
		exit 1
	fi;
	lynx -dump -width=500 "$result" > $tempout
else
	result=$titleurl
fi;
if $DEBUG
then
	echo "[imdb-search] Ergebnis: $result"
fi;



#Formatiere die Daten
>$moviedata
echo "IMDb-Page of   '$(grep 'IMDb >' $tempout | cut -d">" -f2-)'" >> $moviedata
echo >> $moviedata
grep 'Nutzer-Bewertung' $tempout | sed -e 's/\[[0-9a-zA-Z\.]*\]//g' >> $moviedata
awk '/^.+Overview/,/.*Message Boards.*/' $tempout | sed -e 's/\[[0-9a-zA-Z\.]*\]//g;/^$/d;s/_//g'|sed -e '/^ *$/d' >> $moviedata
sed -i 's/ *Overview$/\n---Overview---/' $moviedata
sed -i 's/ *Cast.*/\n---Cast---/' $moviedata
sed -i 's/ *Additional Details$/\n---Additional Details---/' $moviedata
sed -i 's/ *Fun Stuff$/\n---Fun Stuff---/' $moviedata
sed -i 's/ *User Comments.*/\n---User Comments---/' $moviedata
sed -i 's/FAQ$/\n---FAQ---/g' $moviedata
sed -i 's/^MOVIEmeter: ?/\n---Movie Meter---/g' $moviedata
sed -i 's/mehr\.\.\.$//g;s/why?//g;/.*Message Boards.*/d;s/^ *//g;s/ *\.\.\. */ \.\.\. /g'  $moviedata
sed -i 's/^\(.*\):$/\n---\1---/g' $moviedata



#Zeige im OSD falls aus commands.conf aufgerufen
if [ $calltype = $CMDCONFCALL ]
then
	dummy=$($svdrp hitk Commands)
	dummy=$($svdrp hitk $commandNo)
elif [ $calltype = $RECCMDCONFCALL ]
then
	cat /tmp/moviedata
fi;

#cleanup
#rm $tempout

exit 0


